Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JPEG.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JPEG.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JPEG.pm	(revision 34921)
@@ -12,12 +12,15 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.13';
-
-sub ProcessScalado($$$);
+$VERSION = '1.30';
+
 sub ProcessOcad($$$);
-
-# (this main JPEG table is for documentation purposes only)
+sub ProcessJPEG_HDR($$$);
+
+# (most of the tags in this table are for documentation purposes only)
 %Image::ExifTool::JPEG::Main = (
-    NOTES => 'This table lists information extracted by ExifTool from JPEG images.',
+    NOTES => q{
+        This table lists information extracted by ExifTool from JPEG images. See
+        L<https://www.w3.org/Graphics/JPEG/jfif3.pdf> for the JPEG specification.
+    },
     APP0 => [{
         Name => 'JFIF',
@@ -57,4 +60,15 @@
         Condition => '$$valPt =~ /^QVCI\0/',
         SubDirectory => { TagTable => 'Image::ExifTool::Casio::QVCI' },
+      }, {
+        Name => 'FLIR',
+        Condition => '$$valPt =~ /^FLIR\0/',
+        SubDirectory => { TagTable => 'Image::ExifTool::FLIR::FFF' },
+      }, {
+        Name => 'RawThermalImage', # (from Parrot Bebop-Pro Thermal drone)
+        Condition => '$$valPt =~ /^PARROT\0(II\x2a\0|MM\0\x2a)/',
+        Groups => { 0 => 'APP1', 1 => 'Parrot', 2 => 'Preview' },
+        Notes => 'thermal image from Parrot Bebop-Pro Thermal drone',
+        RawConv => 'substr($val, 7)',
+        Binary => 1,
     }],
     APP2 => [{
@@ -72,6 +86,6 @@
       }, {
         Name => 'PreviewImage',
-        Condition => '$$valPt =~ /^\xff\xd8\xff\xdb/',
-        Notes => 'Samsung large preview',
+        Condition => '$$valPt =~ /^(|QVGA\0|BGTH)\xff\xd8\xff\xdb/',
+        Notes => 'Samsung APP2 preview image', # (Samsung/GoPro="", BenQ="QVGA\0", Digilife="BGTH")
     }],
     APP3 => [{
@@ -84,12 +98,18 @@
         SubDirectory => { TagTable => 'Image::ExifTool::Stim::Main' },
       }, {
+        Name => 'ThermalData', # (written by DJI FLIR models)
+        Condition => '$$self{Make} eq "DJI"',
+        Notes => 'DJI raw thermal data',
+        Groups => { 0 => 'APP3', 1 => 'DJI', 2 => 'Image' },
+        Binary => 1,
+      }, {
         Name => 'PreviewImage', # (written by HP R837 and Samsung S1060)
         Condition => '$$valPt =~ /^\xff\xd8\xff\xdb/',
-        Notes => 'Hewlett-Packard or Samsung preview image',
+        Notes => 'Samsung/HP preview image', # (Samsung, HP, BenQ)
     }],
     APP4 => [{
         Name => 'Scalado',
         Condition => '$$valPt =~ /^SCALADO\0/',
-        SubDirectory => { TagTable => 'Image::ExifTool::JPEG::Scalado' },
+        SubDirectory => { TagTable => 'Image::ExifTool::Scalado::Main' },
       }, {
         Name => 'FPXR', # (non-standard location written by some HP models)
@@ -97,12 +117,29 @@
         SubDirectory => { TagTable => 'Image::ExifTool::FlashPix::Main' },
       }, {
-        Name => 'PreviewImage', # (written by S1060)
-        Notes => 'Continued Samsung preview from APP3',
-    }],
-    APP5 => {
+        Name => 'ThermalParams', # (written by DJI FLIR models)
+        Condition => '$$self{Make} eq "DJI" and $$valPt =~ /^\xaa\x55\x12\x06/',
+        SubDirectory => { TagTable => 'Image::ExifTool::DJI::ThermalParams' },
+      }, {
+        Name => 'PreviewImage', # (eg. Samsung S1060)
+        Notes => 'continued from APP3',
+    }],
+    APP5 => [{
         Name => 'RMETA',
         Condition => '$$valPt =~ /^RMETA\0/',
         SubDirectory => { TagTable => 'Image::ExifTool::Ricoh::RMETA' },
-    },
+      }, {
+        Name => 'SamsungUniqueID',
+        Condition => '$$valPt =~ /ssuniqueid\0/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Samsung::APP5' },
+      }, {
+        Name => 'ThermalCalibration', # (written by DJI FLIR models)
+        Condition => '$$self{Make} eq "DJI"',
+        Notes => 'DJI thermal calibration data',
+        Groups => { 0 => 'APP5', 1 => 'DJI', 2 => 'Image' },
+        Binary => 1,
+      }, {
+        Name => 'PreviewImage', # (eg. BenQ DC E1050)
+        Notes => 'continued from APP4',
+    }],
     APP6 => [{
         Name => 'EPPIM',
@@ -117,4 +154,28 @@
         Condition => '$$valPt =~ /^TDHD\x01\0\0\0/',
         SubDirectory => { TagTable => 'Image::ExifTool::HP::TDHD' },
+      }, {
+        Name => 'GoPro',
+        Condition => '$$valPt =~ /^GoPro\0/',
+        SubDirectory => { TagTable => 'Image::ExifTool::GoPro::GPMF' },
+      # also seen Motorola APP6 "MMIMETA\0", with sub-types: AL3A,ALED,MMI0,MOTD,QC3A
+      }, {
+        Name => 'DJI_DTAT', # (written by ZH20T)
+        Condition => '$$valPt =~ /^DTAT\0\0.\{/s',
+        Groups => { 0 => 'APP6', 1 => 'DJI' },
+        Notes => 'DJI Thermal Analysis Tool record',
+        ValueConv => 'substr($val,7)',
+    }],
+    APP7 => [{
+        Name => 'Pentax',
+        Condition => '$$valPt =~ /^PENTAX \0/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Pentax::Main' },
+      }, {
+        Name => 'Huawei',
+        Condition => '$$valPt =~ /^HUAWEI\0\0/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Unknown::Main' },
+      }, {
+        Name => 'Qualcomm',
+        Condition => '$$valPt =~ /^\x1aQualcomm Camera Attributes/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Qualcomm::Main' },
     }],
     APP8 => {
@@ -123,8 +184,18 @@
         SubDirectory => { TagTable => 'Image::ExifTool::JPEG::SPIFF' },
     },
+    APP9 => {
+        Name => 'MediaJukebox',
+        Condition => '$$valPt =~ /^Media Jukebox\0/',
+        SubDirectory => { TagTable => 'Image::ExifTool::JPEG::MediaJukebox' },
+    },
     APP10 => {
         Name => 'Comment',
         Condition => '$$valPt =~ /^UNICODE\0/',
         Notes => 'PhotoStudio Unicode comment',
+    },
+    APP11 => {
+        Name => 'JPEG-HDR',
+        Condition => '$$valPt =~ /^HDR_RI /',
+        SubDirectory => { TagTable => 'Image::ExifTool::JPEG::HDR' },
     },
     APP12 => [{
@@ -149,4 +220,5 @@
         Name => 'Adobe',
         Condition => '$$valPt =~ /^Adobe/',
+        Writable => 2,  # (for docs only)
         SubDirectory => { TagTable => 'Image::ExifTool::JPEG::Adobe' },
     },
@@ -156,9 +228,10 @@
         SubDirectory => { TagTable => 'Image::ExifTool::JPEG::GraphConv' },
     },
+    # APP15 - Also unknown "TEXT\0" segment stored by Casio/FujiFilm
     COM => {
         Name => 'Comment',
         # note: flag as writable for documentation, but it won't show up
         # in the TagLookup as writable because there is no WRITE_PROC
-        Writable => 1,
+        Writable => 2,
     },
     SOF => {
@@ -168,5 +241,5 @@
     DQT => {
         Name => 'DefineQuantizationTable',
-        Notes => 'used to calculate the Extra:JPEGDigest tag value',
+        Notes => 'used to calculate the Extra JPEGDigest tag value',
     },
     Trailer => [{
@@ -194,7 +267,18 @@
         SubDirectory => { TagTable => 'Image::ExifTool::MIE::Main' },
       }, {
+        Name => 'Samsung',
+        Condition => '$$valPt =~ /QDIOBS$/',
+        SubDirectory => { TagTable => 'Image::ExifTool::Samsung::Trailer' },
+      }, {
+        Name => 'EmbeddedVideo',
+        Notes => 'extracted only when ExtractEmbedded option is used',
+        Condition => '$$valPt =~ /^.{4}ftyp/s',
+      }, {
+        Name => 'Insta360',
+        Condition => '$$valPt =~ /8db42d694ccc418790edff439fe026bf$/',
+      }, {
         Name => 'PreviewImage',
         Condition => '$$valPt =~ /^\xff\xd8\xff/',
-        Writable => 1,  # (for docs only)
+        Writable => 2,  # (for docs only)
     }],
 );
@@ -210,4 +294,5 @@
         Name => 'PrintIM',
         # must set Writable here so this tag will be saved with MakerNotes option
+        # (but it isn't actually writable because there is no WRITE_PROC)
         Writable => 'undef',
         Description => 'Print Image Matching',
@@ -218,5 +303,5 @@
 );
 
-# SPIFF APP8 segment.  Refs:
+# APP8 SPIFF segment.  Refs:
 # 1) http://www.fileformat.info/format/spiff/
 # 2) http://www.jpeg.org/public/spiff.pdf
@@ -305,4 +390,46 @@
 );
 
+# APP9 Media Jukebox segment (ref PH)
+%Image::ExifTool::JPEG::MediaJukebox = (
+    GROUPS => { 0 => 'XML', 1 => 'MediaJukebox', 2 => 'Image' },
+    VARS => { NO_ID => 1 },
+    NOTES => 'Tags found in the XML metadata of the APP9 "Media Jukebox" segment.',
+    Date => {
+        Groups => { 2 => 'Time' },
+        # convert from days since Dec 30, 1899 to seconds since Jan 1, 1970
+        ValueConv => 'ConvertUnixTime(($val - (70 * 365 + 17 + 2)) * 24 * 3600)',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    Album        => { },
+    Caption      => { },
+    Keywords     => { },
+    Name         => { },
+    People       => { },
+    Places       => { },
+    Tool_Name    => { },
+    Tool_Version => { },
+);
+
+# JPEG-HDR APP11 information (ref PH, guessed from http://anyhere.com/gward/papers/cic05.pdf)
+%Image::ExifTool::JPEG::HDR = (
+    GROUPS => { 0 => 'APP11', 1 => 'JPEG-HDR', 2 => 'Image' },
+    PROCESS_PROC => \&ProcessJPEG_HDR,
+    TAG_PREFIX => '', # (no prefix for unknown tags)
+    NOTES => 'Information extracted from APP11 of a JPEG-HDR image.',
+    ver => 'JPEG-HDRVersion',
+    # (need names for the next 3 tags)
+    ln0 => { Description => 'Ln0' },
+    ln1 => { Description => 'Ln1' },
+    s2n => { Description => 'S2n' },
+    alp => { Name => 'Alpha' }, # (Alpha/Beta are saturation parameters)
+    bet => { Name => 'Beta' },
+    cor => { Name => 'CorrectionMethod' },
+    RatioImage => {
+        Groups => { 2 => 'Preview' },
+        Notes => 'the embedded JPEG-compressed ratio image',
+        Binary => 1,
+    },
+);
+
 # AdobeCM APP13 (no references)
 %Image::ExifTool::JPEG::AdobeCM = (
@@ -310,5 +437,5 @@
     GROUPS => { 0 => 'APP13', 1 => 'AdobeCM', 2 => 'Image' },
     NOTES => q{
-        The "Adobe_CM" APP13 segment presumably contains color management
+        The APP13 "Adobe_CM" segment presumably contains color management
         information, but the meaning of the data is currently unknown.  If anyone
         has an idea about what this means, please let me know.
@@ -324,16 +451,27 @@
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
     GROUPS => { 0 => 'APP14', 1 => 'Adobe', 2 => 'Image' },
-    NOTES => 'The "Adobe" APP14 segment stores image encoding information for DCT filters.',
+    NOTES => q{
+        The APP14 "Adobe" segment stores image encoding information for DCT filters.
+        This segment may be copied or deleted as a block using the Extra "Adobe"
+        tag, but note that it is not deleted by default when deleting all metadata
+        because it may affect the appearance of the image.
+    },
     FORMAT => 'int16u',
     0 => 'DCTEncodeVersion',
     1 => {
         Name => 'APP14Flags0',
-        PrintConv => { BITMASK => {
-            15 => 'Encoded with Blend=1 downsampling'
-        } },
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                15 => 'Encoded with Blend=1 downsampling'
+            },
+        },
     },
     2 => {
         Name => 'APP14Flags1',
-        PrintConv => { BITMASK => { } },
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => { },
+        },
     },
     3 => {
@@ -355,5 +493,5 @@
 );
 
-# AVI1 APP0 segment (ref http://www.schnarff.com/file-formats/bmp/BMPDIB.TXT)
+# APP0 AVI1 segment (ref http://www.schnarff.com/file-formats/bmp/BMPDIB.TXT)
 %Image::ExifTool::JPEG::AVI1 = (
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
@@ -368,11 +506,12 @@
             2 => 'Even',
         },
-    },    
-);
-
-# Ocad APP0 segment (ref PH)
+    },
+);
+
+# APP0 Ocad segment (ref PH)
 %Image::ExifTool::JPEG::Ocad = (
     PROCESS_PROC => \&ProcessOcad,
     GROUPS => { 0 => 'APP0', 1 => 'Ocad', 2 => 'Image' },
+    TAG_PREFIX => 'Ocad',
     FIRST_ENTRY => 0,
     NOTES => q{
@@ -386,5 +525,5 @@
 );
 
-# NITF APP6 segment (National Imagery Transmission Format)
+# APP6 NITF segment (National Imagery Transmission Format)
 # ref http://www.gwg.nga.mil/ntb/baseline/docs/n010697/bwcguide25aug98.pdf
 %Image::ExifTool::JPEG::NITF = (
@@ -446,44 +585,4 @@
 );
 
-# information written by Scalado software (PhotoFusion maybe?)
-%Image::ExifTool::JPEG::Scalado = (
-    GROUPS => { 0 => 'APP4', 1 => 'Scalado', 2 => 'Image' },
-    PROCESS_PROC => \&ProcessScalado,
-    TAG_PREFIX => 'Scalado',
-    FORMAT => 'int32s',
-    # I presume this was written by 
-    NOTES => q{
-        Tags extracted from the JPEG APP4 "SCALADO" segment (presumably written by
-        Scalado mobile software, L<http://www.scalado.com/>).
-    },
-    SPMO => {
-        Name => 'DataLength',
-        Unkown => 1,
-    },
-    WDTH => {
-        Name => 'PreviewImageWidth',
-        ValueConv => '$val ? abs($val) : undef',
-    },
-    HGHT => {
-        Name => 'PreviewImageHeight',
-        ValueConv => '$val ? abs($val) : undef',
-    },
-    QUAL => {
-        Name => 'PreviewQuality',
-        ValueConv => '$val ? abs($val) : undef',
-    },
-    # tags not yet decoded with observed values:
-    # CHKH: 0, -9010
-    # CHKL: -2664, -12852
-    # CLEN: -1024
-    # CSPC: -2232593
-    # DATA: (+ve data length)
-    # HDEC: 0
-    # MAIN: 0
-    # SCI0: (+ve data length)
-    # SCX1: (+ve data length)
-    # WDEC: 0
-);
-
 #------------------------------------------------------------------------------
 # Extract information from the JPEG APP0 Ocad segment
@@ -492,15 +591,13 @@
 sub ProcessOcad($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
-    $exifTool->VerboseDir('APP0 Ocad', undef, length $$dataPt);
+    $et->VerboseDir('APP0 Ocad', undef, length $$dataPt);
     for (;;) {
         last unless $$dataPt =~ /\$(\w+):([^\0\$]+)/g;
         my ($tag, $val) = ($1, $2);
-        $val =~ s/(^\s+|\s+$)//g;   # remove leading/trailing spaces
-        unless ($$tagTablePtr{$tag}) {
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, { Name => "Ocad_$tag" });
-        }
-        $exifTool->HandleTag($tagTablePtr, $tag, $val);
+        $val =~ s/^\s+//; $val =~ s/\s+$//;     # remove leading/trailing spaces
+        AddTagToTable($tagTablePtr, $tag) unless $$tagTablePtr{$tag};
+        $et->HandleTag($tagTablePtr, $tag, $val);
     }
     return 1;
@@ -508,29 +605,21 @@
 
 #------------------------------------------------------------------------------
-# Extract information from the JPEG APP4 SCALADO segment
+# Extract information from the JPEG APP0 Ocad segment
 # Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
 # Returns: 1 on success
-sub ProcessScalado($$$)
+sub ProcessJPEG_HDR($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
-    my $pos = 0;
-    my $end = length $$dataPt;
-    SetByteOrder('MM');
-    $exifTool->VerboseDir('APP4 SCALADO', undef, $end);
-    for (;;) {
-        last if $pos + 12 > $end;
-        my $tag = substr($$dataPt, $pos, 4);
-        my $unk = Get32u($dataPt, $pos + 4); # (what is this?)
-        $exifTool->HandleTag($tagTablePtr, $tag, undef,
-            DataPt  => $dataPt,
-            Start   => $pos + 8,
-            Size    => 4,
-            Extra   => ", unk $unk",
-        );
-        # shorten directory size by length of SPMO
-        $end -= Get32u($dataPt, $pos + 8) if $tag eq 'SPMO';
-        $pos += 12;
+    $$dataPt =~ /~\0/g or $et->Warn('Unrecognized JPEG-HDR format'), return 0;
+    my $pos = pos $$dataPt;
+    my $meta = substr($$dataPt, 7, $pos-9);
+    $et->VerboseDir('APP11 JPEG-HDR', undef, length $$dataPt);
+    while ($meta =~ /(\w+)=([^,\s]*)/g) {
+        my ($tag, $val) = ($1, $2);
+        AddTagToTable($tagTablePtr, $tag) unless $$tagTablePtr{$tag};
+        $et->HandleTag($tagTablePtr, $tag, $val);
     }
+    $et->HandleTag($tagTablePtr, 'RatioImage', substr($$dataPt, $pos));
     return 1;
 }
@@ -556,5 +645,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JPEGDigest.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JPEGDigest.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JPEGDigest.pm	(revision 34921)
@@ -2,10 +2,12 @@
 # File:         JPEGDigest.pm
 #
-# Description:  Lookup for JPEGDigest values
+# Description:  Calculate JPEGDigest and JPEGQualityEstimate
 #
 # Revisions:    2008/09/15 - P. Harvey Created
+#               2016/01/05 - PH Added calculation of JPEGQualityEstimate
 #
 # References:   JD) Jens Duttke
 #               2) Franz Buchinger private communication
+#               3) https://github.com/ImageMagick/ImageMagick/blob/master/coders/jpeg.c
 #------------------------------------------------------------------------------
 
@@ -14,5 +16,5 @@
 use vars qw($VERSION);
 
-$VERSION = '1.02';
+$VERSION = '1.06';
 
 # the print conversion for the JPEGDigest tag
@@ -282,5 +284,5 @@
     '4c3c425b4024b68c0de03904a825bc35:111111' => 'Adobe Lightroom, Quality 93% - 100%',
 
-    # Tested with Adobe Photoshop CS2 Version 9.0.2 (Win) - "Save as..." (RGB/CYMK)
+    # Tested with Adobe Photoshop CS2 Version 9.0.2 (Win) - "Save as..." (RGB/CMYK)
     '683506a889c78d9bc230a0c7ee5f62f3:221111' => 'Adobe Photoshop, Quality 0',
     'bc490651af6592cd1dbbbc4fa2cfa1fb:221111' => 'Adobe Photoshop, Quality 1',
@@ -2443,12 +2445,107 @@
 
 #------------------------------------------------------------------------------
-# Calculate JPEGDigest
+# Estimate JPEG quality from quantization tables (ref 3)
+# Inputs: 0) 1) DQT segments array ref
+# Returns: JPEG quality, or undefined if it can't be calculated
+sub EstimateQuality($)
+{
+    local $_;
+    my $dqtList = shift;
+    my ($i, $dqt, @qtbl, $quality, @hash, @sums);
+
+    # unpack DQT segments and sum quantization tables
+    my $sum=0;
+DQT: foreach $dqt (@$dqtList) {
+        next unless defined $dqt;
+        for ($i=1; $i+64<=length($dqt); $i+=65) {
+            my @qt = unpack("x$i C64", $dqt);
+            $sum += $_ foreach @qt;
+            push @qtbl, \@qt;
+            last DQT if @qtbl >= 4;
+        }
+    }
+    return undef unless @qtbl;
+
+    my $qval = $qtbl[0][2] + $qtbl[0][53];
+    if (@qtbl > 1) {
+        # color JPEG
+        $qval += $qtbl[1][0] + $qtbl[1][63];
+        @hash =(
+            1020, 1015,  932,  848,  780,  735,  702,  679,  660,  645,
+             632,  623,  613,  607,  600,  594,  589,  585,  581,  571,
+             555,  542,  529,  514,  494,  474,  457,  439,  424,  410,
+             397,  386,  373,  364,  351,  341,  334,  324,  317,  309,
+             299,  294,  287,  279,  274,  267,  262,  257,  251,  247,
+             243,  237,  232,  227,  222,  217,  213,  207,  202,  198,
+             192,  188,  183,  177,  173,  168,  163,  157,  153,  148,
+             143,  139,  132,  128,  125,  119,  115,  108,  104,   99,
+              94,   90,   84,   79,   74,   70,   64,   59,   55,   49,
+              45,   40,   34,   30,   25,   20,   15,   11,    6,    4
+        );
+        @sums = (
+            32640, 32635, 32266, 31495, 30665, 29804, 29146, 28599, 28104, 27670,
+            27225, 26725, 26210, 25716, 25240, 24789, 24373, 23946, 23572, 22846,
+            21801, 20842, 19949, 19121, 18386, 17651, 16998, 16349, 15800, 15247,
+            14783, 14321, 13859, 13535, 13081, 12702, 12423, 12056, 11779, 11513,
+            11135, 10955, 10676, 10392, 10208,  9928,  9747,  9564,  9369,  9193,
+             9017,  8822,  8639,  8458,  8270,  8084,  7896,  7710,  7527,  7347,
+             7156,  6977,  6788,  6607,  6422,  6236,  6054,  5867,  5684,  5495,
+             5305,  5128,  4945,  4751,  4638,  4442,  4248,  4065,  3888,  3698,
+             3509,  3326,  3139,  2957,  2775,  2586,  2405,  2216,  2037,  1846,
+             1666,  1483,  1297,  1109,   927,   735,   554,   375,   201,   128
+        );
+    } else {
+        # greyscale JPEG
+        @hash = (
+            510,  505,  422,  380,  355,  338,  326,  318,  311,  305,
+            300,  297,  293,  291,  288,  286,  284,  283,  281,  280,
+            279,  278,  277,  273,  262,  251,  243,  233,  225,  218,
+            211,  205,  198,  193,  186,  181,  177,  172,  168,  164,
+            158,  156,  152,  148,  145,  142,  139,  136,  133,  131,
+            129,  126,  123,  120,  118,  115,  113,  110,  107,  105,
+            102,  100,   97,   94,   92,   89,   87,   83,   81,   79,
+             76,   74,   70,   68,   66,   63,   61,   57,   55,   52,
+             50,   48,   44,   42,   39,   37,   34,   31,   29,   26,
+             24,   21,   18,   16,   13,   11,    8,    6,    3,    2
+        );
+        @sums = (
+            16320, 16315, 15946, 15277, 14655, 14073, 13623, 13230, 12859, 12560,
+            12240, 11861, 11456, 11081, 10714, 10360, 10027,  9679,  9368,  9056,
+             8680,  8331,  7995,  7668,  7376,  7084,  6823,  6562,  6345,  6125,
+             5939,  5756,  5571,  5421,  5240,  5086,  4976,  4829,  4719,  4616,
+             4463,  4393,  4280,  4166,  4092,  3980,  3909,  3835,  3755,  3688,
+             3621,  3541,  3467,  3396,  3323,  3247,  3170,  3096,  3021,  2952,
+             2874,  2804,  2727,  2657,  2583,  2509,  2437,  2362,  2290,  2211,
+             2136,  2068,  1996,  1915,  1858,  1773,  1692,  1620,  1552,  1477,
+             1398,  1326,  1251,  1179,  1109,  1031,   961,   884,   814,   736,
+              667,   592,   518,   441,   369,   292,   221,   151,    86,    64
+        );
+    }
+    for ($i=0; $i<100; ++$i) {
+        next if $qval < $hash[$i] and $sum < $sums[$i];
+        $quality = $i + 1 if ($qval <= $hash[$i] and $sum <= $sums[$i]) or $i >= 50;
+        last;
+    }
+    return $quality;
+}
+
+#------------------------------------------------------------------------------
+# Calculate JPEGDigest and/or JPEGQualityEstimate
 # Inputs: 0) ExifTool object ref, 1) DQT segments array ref, 2) subsampling string
 sub Calculate($$$)
 {
-    my ($exifTool, $dqtList, $subSampling) = @_;
-
-    unless (eval 'require Digest::MD5') {
-        $exifTool->Warn('Digest::MD5 must be installed to calculate JPEGDigest');
+    my ($et, $dqtList, $subSampling) = @_;
+
+    # estimate JPEG quality if requested
+    my $all = ($$et{OPTIONS}{RequestAll} and $$et{OPTIONS}{RequestAll} > 2);
+    if ($all or $$et{REQ_TAG_LOOKUP}{jpegqualityestimate}) {
+        my $quality = EstimateQuality($dqtList);
+        $quality = '<unknown>' unless defined $quality;
+        $et->FoundTag('JPEGQualityEstimate', $quality);
+    }
+    return unless ($all or $$et{REQ_TAG_LOOKUP}{jpegdigest}) and $subSampling;
+
+    unless (eval { require Digest::MD5 }) {
+        $et->Warn('Digest::MD5 must be installed to calculate JPEGDigest');
         return;
     }
@@ -2470,5 +2567,5 @@
     # bulk up the documentation and slow down loading unnecessarily
     $Image::ExifTool::Extra{JPEGDigest}{PrintConv} = \%PrintConv;
-    $exifTool->FoundTag('JPEGDigest', $md5);
+    $et->FoundTag('JPEGDigest', $md5);
 }
 
@@ -2480,5 +2577,5 @@
 =head1 NAME
 
-Image::ExifTool::JPEGDigest - Lookup for JPEGDigest values
+Image::ExifTool::JPEGDigest - Calculate JPEGDigest and JPEGQualityEstimate
 
 =head1 SYNOPSIS
@@ -2489,13 +2586,22 @@
 
 This module contains a lookup for values of the JPEG DQT digest, allowing
-some image identification from JPEG data alone.
+some image identification from JPEG data alone.  It also calculates an
+estimated JPEG quality if requested.
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
 under the same terms as Perl itself.
 
+=head1 REFERENCES
+
+=over 4
+
+=item L<https://github.com/ImageMagick/ImageMagick/blob/master/coders/jpeg.c>
+
+=back
+
 =head1 ACKNOWLEDGEMENTS
 
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JSON.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JSON.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/JSON.pm	(revision 34921)
@@ -0,0 +1,165 @@
+#------------------------------------------------------------------------------
+# File:         JSON.pm
+#
+# Description:  Read JSON files
+#
+# Notes:        Set ExifTool MissingTagValue to "null" to ignore JSON nulls
+#
+# Revisions:    2017/03/13 - P. Harvey Created
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::JSON;
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+use Image::ExifTool::Import;
+
+$VERSION = '1.02';
+
+sub ProcessTag($$$$%);
+
+%Image::ExifTool::JSON::Main = (
+    GROUPS => { 0 => 'JSON', 1 => 'JSON', 2 => 'Other' },
+    VARS => { NO_ID => 1 },
+    NOTES => q{
+        Other than a few tags in the table below, JSON tags have not been
+        pre-defined.  However, ExifTool will read any existing tags from basic
+        JSON-formatted files.
+    },
+    # ON1 settings tags
+    ON1_SettingsData => {
+        RawConv => q{
+            require Image::ExifTool::XMP;
+            $val = Image::ExifTool::XMP::DecodeBase64($val);
+        },
+        SubDirectory => { TagTable => 'Image::ExifTool::PLIST::Main' },
+    },
+    ON1_SettingsMetadataCreated     => { Groups => { 2 => 'Time' } },
+    ON1_SettingsMetadataModified    => { Groups => { 2 => 'Time' } },
+    ON1_SettingsMetadataName        => { },
+    ON1_SettingsMetadataPluginID    => { },
+    ON1_SettingsMetadataTimestamp   => { Groups => { 2 => 'Time' } },
+    ON1_SettingsMetadataUsage       => { },
+    ON1_SettingsMetadataVisibleToUser=>{ },
+);
+
+#------------------------------------------------------------------------------
+# Store a tag value
+# Inputs: 0) ExifTool ref, 1) tag table, 2) tag ID, 3) value, 4) tagInfo flags
+sub FoundTag($$$$%)
+{
+    my ($et, $tagTablePtr, $tag, $val, %flags) = @_;
+
+    # special case to reformat ON1 tag names
+    if ($tag =~ s/^settings\w{8}-\w{4}-\w{4}-\w{4}-\w{12}(Data|Metadata.+)$/ON1_Settings$1/) {
+        $et->OverrideFileType('ONP','application/on1') if $$et{FILE_TYPE} eq 'JSON';
+    }
+
+    # avoid conflict with special table entries
+    $tag .= '!' if $Image::ExifTool::specialTags{$tag};
+
+    AddTagToTable($tagTablePtr, $tag, {
+        Name => Image::ExifTool::MakeTagName($tag),
+        %flags,
+        Temporary => 1,
+    }) unless $$tagTablePtr{$tag};
+
+    $et->HandleTag($tagTablePtr, $tag, $val);
+}
+
+#------------------------------------------------------------------------------
+# Process a JSON tag
+# Inputs: 0) ExifTool ref, 1) tag table, 2) tag ID, 3) value, 4) tagInfo flags
+# - expands structures into flattened tags as required
+sub ProcessTag($$$$%)
+{
+    local $_;
+    my ($et, $tagTablePtr, $tag, $val, %flags) = @_;
+
+    if (ref $val eq 'HASH') {
+        if ($et->Options('Struct')) {
+            FoundTag($et, $tagTablePtr, $tag, $val, %flags, Struct => 1);
+            return unless $et->Options('Struct') > 1;
+        }
+        foreach (sort keys %$val) {
+            ProcessTag($et, $tagTablePtr, $tag . ucfirst, $$val{$_}, %flags, Flat => 1);
+        }
+    } elsif (ref $val eq 'ARRAY') {
+        foreach (@$val) {
+            ProcessTag($et, $tagTablePtr, $tag, $_, %flags, List => 1);
+        }
+    } elsif (defined $val) {
+        FoundTag($et, $tagTablePtr, $tag, $val, %flags);
+    }
+}
+
+#------------------------------------------------------------------------------
+# Extract meta information from a JSON file
+# Inputs: 0) ExifTool object reference, 1) dirInfo reference
+# Returns: 1 on success, 0 if this wasn't a recognized JSON file
+sub ProcessJSON($$)
+{
+    local $_;
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my $structOpt = $et->Options('Struct');
+    my (%database, $key, $tag);
+
+    # read information from JSON file into database structure
+    my $err = Image::ExifTool::Import::ReadJSON($raf, \%database,
+        $et->Options('MissingTagValue'), $et->Options('Charset'));
+
+    return 0 if $err or not %database;
+
+    $et->SetFileType();
+
+    my $tagTablePtr = GetTagTable('Image::ExifTool::JSON::Main');
+
+    # remove any old tag definitions in case they change flags
+    foreach $key (TagTableKeys($tagTablePtr)) {
+        delete $$tagTablePtr{$key} if $$tagTablePtr{$key}{Temporary};
+    }
+
+    # extract tags from JSON database
+    foreach $key (sort keys %database) {
+        foreach $tag (sort keys %{$database{$key}}) {
+            my $val = $database{$key}{$tag};
+            # (ignore SourceFile if generated automatically by ReadJSON)
+            next if $tag eq 'SourceFile' and defined $val and $val eq '*';
+            ProcessTag($et, $tagTablePtr, $tag, $val);
+        }
+    }
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::JSON - Read JSON files
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool read
+information from JSON files.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/JSON Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
